Codeforces - Good Bye 2014 (今年最后一次CF!!)


这几次打比赛都打得比较蛋疼,,总的来说还是太差劲了!!

做也做的慢,看题也看的慢,,而且看懂了还不会做大哭还得费很大劲啊!!微笑



A. New Year Transportation
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

New Year is coming in Line World! In this world, there are n cells numbered by integers from 1 to n, as a 1 × n board. People live in cells. However, it was hard to move between distinct cells, because of the difficulty of escaping the cell. People wanted to meet people who live in other cells.

So, user tncks0121 has made a transportation system to move between these cells, to celebrate the New Year. First, he thought of n - 1positive integers a1, a2, ..., an - 1. For every integer i where 1 ≤ in - 1 the condition 1 ≤ ain - i holds. Next, he made n - 1portals, numbered by integers from 1 to n - 1. The i-th (1 ≤ in - 1) portal connects cell i and cell (i + ai), and one can travel from cell i to cell (i + ai) using the i-th portal. Unfortunately, one cannot use the portal backwards, which means one cannot move from cell(i + ai) to cell i using the i-th portal. It is easy to see that because of condition 1 ≤ ain - i one can't leave the Line World using portals.

Currently, I am standing at cell 1, and I want to go to cell t. However, I don't know whether it is possible to go there. Please determine whether I can go to cell t by only using the construted transportation system.

Input

The first line contains two space-separated integers n (3 ≤ n ≤ 3 × 104) and t (2 ≤ tn) — the number of cells, and the index of the cell which I want to go to.

The second line contains n - 1 space-separated integers a1, a2, ..., an - 1 (1 ≤ ain - i). It is guaranteed, that using the given transportation system, one cannot leave the Line World.

Output

If I can go to cell t using the transportation system, print "YES". Otherwise, print "NO".

Sample test(s)
input
8 4
1 2 1 2 1 2 1
output
YES
input
8 5
1 2 1 2 1 1 1
output
NO
Note

In the first sample, the visited cells are: 1, 2, 4; so we can successfully visit the cell 4.

In the second sample, the possible cells to visit are: 1, 2, 4, 6, 7, 8; so we can't visit the cell 5, which we want to visit.




思路:直接模拟扫过去就ok了


AC代码:

#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;

int a[30005];

int main()
{
    int n, t;
    while(scanf("%d %d", &n, &t) != EOF)
    {
        for(int i=0; i<n-1; i++)
        {
            scanf("%d", &a[i]);
        }
        int tmp = 0, flag = 0;
        for(int i=0; i<n-1; i++)
        {
            tmp += a[i];
            if(tmp == t)
            {
                flag = 1;
                break;
            }
        }
        if(flag) printf("YES\n");
        else printf("NO\n");
    }
    return 0;
} 



B. New Year Permutation
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

User ainta has a permutation p1, p2, ..., pn. As the New Year is coming, he wants to make his permutation as pretty as possible.

Permutation a1, a2, ..., an is prettier than permutation b1, b2, ..., bn, if and only if there exists an integer k (1 ≤ kn) where a1 = b1, a2 = b2, ..., ak - 1 = bk - 1 and ak < bk all holds.

As known, permutation p is so sensitive that it could be only modified by swapping two distinct elements. But swapping two elements is harder than you think. Given an n × n binary matrix A, user ainta can swap the values of pi and pj (1 ≤ i, jnij) if and only if Ai, j = 1.

Given the permutation p and the matrix A, user ainta wants to know the prettiest permutation that he can obtain.

Input

The first line contains an integer n (1 ≤ n ≤ 300) — the size of the permutation p.

The second line contains n space-separated integers p1, p2, ..., pn — the permutation p that user ainta has. Each integer between 1and n occurs exactly once in the given permutation.

Next n lines describe the matrix A. The i-th line contains n characters '0' or '1' and describes the i-th row of A. The j-th character of thei-th line Ai, j is the element on the intersection of the i-th row and the j-th column of A. It is guaranteed that, for all integers i, j where 1 ≤ i < jnAi, j = Aj, i holds. Also, for all integers i where 1 ≤ inAi, i = 0 holds.

Output

In the first and only line, print n space-separated integers, describing the prettiest permutation that can be obtained.

Sample test(s)
input
7
5 2 4 3 6 7 1
0001001
0000000
0000010
1000001
0000000
0010000
1001000
output
1 2 4 3 6 7 5
input
5
4 2 1 5 3
00100
00011
10010
01101
01010
output
1 2 3 4 5
Note

In the first sample, the swap needed to obtain the prettiest permutation is: (p1, p7).

In the second sample, the swaps needed to obtain the prettiest permutation is (p1, p3), (p4, p5), (p3, p4).

permutation p is a sequence of integers p1, p2, ..., pn, consisting of n distinct positive integers, each of them doesn't exceed n. Thei-th element of the permutation p is denoted as pi. The size of the permutation p is denoted as n.




思路:刚开始我都不知道这个题要干啥,,然后就逗比了。。。

就是把连通分量里的东西排序,,,醉了~~


AC代码:

#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;

int n;
char str[305][305];		//用来保存那个01二维数组 
int a[305];				//输入的要排序的数据 
int vis[305];			//记录在一个连通分量上的数据 
int tmp[305];			//把连通分量里的数据移出来排序 

void dfs(int x)			//深搜找连通分量 
{
	if(vis[x]) return;
	vis[x] = 1;
	for(int i=0; i<n; i++) if(str[x][i] == '1') dfs(i);
}

int main()
{
	while(scanf("%d", &n) != EOF)
	{
		for(int i=0; i<n; i++) scanf("%d", &a[i]);
		for(int i=0; i<n; i++) scanf("%s", str[i]);
		for(int i=0; i<n; i++)
			if(!vis[i])
			{
				dfs(i); 
				int k = 0;
				for(int j=0; j<n; j++) if(vis[j]) tmp[k++] = a[j];	//把找到的连通分量保存在tmp数组里 
				sort(tmp, tmp+k); 		//对tmp数组排序 
				k = 0;
				for(int j=0; j<n; j++) if(vis[j]) a[j] = tmp[k++];	//在把排好序的数据存回去 
				memset(vis, 0, sizeof(vis));	//把vis置为0,以便下次再找连通分量 
			}
		for(int i=0; i<n-1; i++) printf("%d ", a[i]);
		printf("%d\n", a[n-1]);
	}
	return 0;
}




C. New Year Book Reading
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

New Year is coming, and Jaehyun decided to read many books during 2015, unlike this year. He has n books numbered by integers from 1 to n. The weight of the i-th (1 ≤ in) book is wi.

As Jaehyun's house is not large enough to have a bookshelf, he keeps the n books by stacking them vertically. When he wants to read a certain book x, he follows the steps described below.

  1. He lifts all the books above book x.
  2. He pushes book x out of the stack.
  3. He puts down the lifted books without changing their order.
  4. After reading book x, he puts book x on the top of the stack.

He decided to read books for m days. In the j-th (1 ≤ jm) day, he will read the book that is numbered with integer bj (1 ≤ bjn). To read the book, he has to use the process described in the paragraph above. It is possible that he decides to re-read the same book several times.

After making this plan, he realized that the total weight of books he should lift during m days would be too heavy. So, he decided to change the order of the stacked books before the New Year comes, and minimize the total weight. You may assume that books can be stacked in any possible order. Note that book that he is going to read on certain step isn't considered as lifted on that step. Can you help him?

Input

The first line contains two space-separated integers n (2 ≤ n ≤ 500) and m (1 ≤ m ≤ 1000) — the number of books, and the number of days for which Jaehyun would read books.

The second line contains n space-separated integers w1, w2, ..., wn (1 ≤ wi ≤ 100) — the weight of each book.

The third line contains m space separated integers b1, b2, ..., bm (1 ≤ bjn) — the order of books that he would read. Note that he can read the same book more than once.

Output

Print the minimum total weight of books he should lift, which can be achieved by rearranging the order of stacked books.

Sample test(s)
input
3 5
1 2 3
1 3 2 3 1
output
12
Note

Here's a picture depicting the example. Each vertical column presents the stacked books.




思路:很好玩的一个题,,虽然不知道做法做法咋来的

不用关心书的顺序。对每本要读的书,往前扫到头或者扫到同一本书,看看中间夹着多少本书,把这些书的重量加上就行了。

注意:扫到同一本书就break,扫到重复的就continue 。


AC代码:

#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;

int w[505];

int main()
{
    int n, m;
    while(scanf("%d %d", &n, &m) != EOF)
    {
        for(int i=1; i<=n; i++)
        {
            scanf("%d", &w[i]);
        }
        int t, ans = 0;
        int vis[505], b[1005];
        for(int j=1; j<=m; j++)
            scanf("%d", &b[j]);
        for(int i=2; i<=m; i++)
        {
            memset(vis, 0, sizeof(vis));
            for(int j=i-1; j>=1; j--)		//从这本书之前开始扫到开头 
            {
            	if(b[j] == b[i]) break;		//扫到同一本书就break 
                if(vis[b[j]]) continue;		//扫到重复的就continue 
                ans += w[b[j]];
                vis[b[j]] = 1;
            }
        }
        printf("%d\n", ans);
    }
    return 0;
} 




版权声明:本文为u014355480原创文章,遵循CC 4.0 BY-SA版权协议,转载请附上原文出处链接和本声明。